# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .test_case_custom_inputs import TestCaseCustomInputs
from .test_case_custom_labels import TestCaseCustomLabels

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class TestCase(pydantic.BaseModel):
    id: typing.Optional[int]
    created_at: typing.Optional[dt.datetime]
    testset_id: int
    user_query: str
    context: typing.Optional[str]
    response: typing.Optional[str]
    ideal: typing.Optional[str]
    full_prompt: typing.Optional[str]
    custom_inputs: typing.Optional[TestCaseCustomInputs]
    custom_labels: typing.Optional[TestCaseCustomLabels]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
